%{
  #include <stdio.h>
  extern void yyerror(char*);
  extern int yylex();
%}

%token TOKEN_a TOKEN_b TOKEN_c TOKEN_EOF

%start SX

%%

SX : S TOKEN_EOF { printf("Done!\n"); } ;
S : TOKEN_a X ;
X : Y | Z ;
Y : TOKEN_b Y TOKEN_b | TOKEN_a ;
Z : Z TOKEN_c | TOKEN_c ;

/*
Z : TOKEN_c R ;
R : TOKEN_c R | /* empty */ 

%%

void yyerror(char *s) {
    printf("Parse error: '%s'\n", s);
}

int main() {
  while (1) {
    printf("Before yyparse...\n");
    yyparse();
    printf("After yyparse\n");
  }

  return 0;
}
